searchData={"items":[{"type":"module","title":"edb","doc":"The (new!) Erlang debugger","ref":"edb.html"},{"type":"function","title":"edb.add_breakpoint/2","doc":"Set a breakpoint on the line of a loaded module on the remote node.","ref":"edb.html#add_breakpoint/2"},{"type":"function","title":"edb.attach/1","doc":"Start a debugging session by attaching to the given node. If edb was already attached to a node, it will get detached first. The attached node may already have a debugging session in progress, in this case, edb joins it. Arguments: * node - the node to attach to * timeout - how long to wait for the node to be up; defaults to 0","ref":"edb.html#attach/1"},{"type":"function","title":"edb.attached_node/0","doc":"Returns the node being debugged. Will raise a not_attached error if not attached.","ref":"edb.html#attached_node/0"},{"type":"function","title":"edb.clear_breakpoint/2","doc":"Clear a previously set breakpoint on the remote node.","ref":"edb.html#clear_breakpoint/2"},{"type":"function","title":"edb.clear_breakpoints/1","doc":"Clear all previously set breakpoints of a module on the remote node.","ref":"edb.html#clear_breakpoints/1"},{"type":"function","title":"edb.continue/0","doc":"Continues the execution on the remote node and returns right away. Returns not_stopped if no process was paused, otherwise resumed .","ref":"edb.html#continue/0"},{"type":"function","title":"edb.detach/0","doc":"Detach from the currently attached node. The debugger session running on the node is left undisturbed.","ref":"edb.html#detach/0"},{"type":"function","title":"edb.exclude_process/1","doc":"Add a single process to the set of processes excluded from debugging. It is equivalent to exclude_processes([{proc, Proc}]) .","ref":"edb.html#exclude_process/1"},{"type":"function","title":"edb.exclude_processes/1","doc":"Extend the set of processes excluded by the debugger. Processes can be specified in the following ways: - by pid, - by being part of an application, - exception list for pids that should not be excluded E.g. a spec like: [ Pid1 , { appication , foo } , { application , bar } , { except , Pid2 } , { except , Pid3 } ] will exclude Pid1 and all processes in applications foo and bar ; however Pid2 and Pid3 are guaranteed not to be excluded, whether they are part of foo , bar , etc. The order of the spec clauses is irrelevant and, in particular, except clauses are global. If any specified processes are currently paused, they will be automatically resumed.","ref":"edb.html#exclude_processes/1"},{"type":"function","title":"edb.excluded_processes/0","doc":"List the pids that will not be stopped by the debugger on the remote node.","ref":"edb.html#excluded_processes/0"},{"type":"function","title":"edb.format/2","doc":null,"ref":"edb.html#format/2"},{"type":"function","title":"edb.get_breakpoints/0","doc":"Get all currently set breakpoints on the remote node.","ref":"edb.html#get_breakpoints/0"},{"type":"function","title":"edb.get_breakpoints_hit/0","doc":"Get the list of processes currently stopped at a breakpoint on the remote node.","ref":"edb.html#get_breakpoints_hit/0"},{"type":"function","title":"edb.is_paused/0","doc":"Check if there exists paused processes.","ref":"edb.html#is_paused/0"},{"type":"function","title":"edb.process_info/1","doc":"Get information about a process managed by the debugger on the remote node.","ref":"edb.html#process_info/1"},{"type":"function","title":"edb.processes/0","doc":"Get the set of processes managed by the debugger on the remote node.","ref":"edb.html#processes/0"},{"type":"function","title":"edb.send_sync_event/1","doc":"Request that a sync event is sent to the given subscription. The process holding the subscription will receive a sync event, with the returned reference as value. This can be used to ensure that there are no events the server is planning to send. Returns {error, unknown_subscription} if the subscription is not known.","ref":"edb.html#send_sync_event/1"},{"type":"function","title":"edb.stack_frame_vars/2","doc":"Get the local variables for a paused processes at a give frame. Equivalent to stack_frame_vars(Pid, 2048) .","ref":"edb.html#stack_frame_vars/2"},{"type":"function","title":"edb.stack_frame_vars/3","doc":"Get the local variables for a paused process at a given frame. The value of FrameId` must be one of the frame-ids returned by `stack_frames/1 , or the call will return undefined . For each variable, the value is returned only if its internal size is at most MaxTermSize , otherwise {too_large, Size, MaxTermSize} is returned. This is to prevent the caller from getting objects that are larger than they are willing to handle.","ref":"edb.html#stack_frame_vars/3"},{"type":"function","title":"edb.stack_frames/1","doc":"Get the stack frames for a paused process. The FrameNo can then be used to retrieve the variables for a particular frame.","ref":"edb.html#stack_frames/1"},{"type":"function","title":"edb.step_out/1","doc":null,"ref":"edb.html#step_out/1"},{"type":"function","title":"edb.step_over/1","doc":null,"ref":"edb.html#step_over/1"},{"type":"function","title":"edb.subscribe/0","doc":"Subscribe caller process to receive debugging events from the attached node. The caller process can then expect messages of type event_envelope(event()) , with the specified subscription in the envelope. A process can hold multiple subscriptions and can unsubscribe from them individually.","ref":"edb.html#subscribe/0"},{"type":"function","title":"edb.terminate/0","doc":"Terminates the debugging session. Detaches from the node, but stopping the debugger running on it. That means that breakpoints will be cleared, and any paused processes will be resumed, etc.","ref":"edb.html#terminate/0"},{"type":"function","title":"edb.unexclude_processes/1","doc":"Removes an exclusion previously added with exclude_processes/1 . If there are currently paused processes, any specified processes will be paused as well.","ref":"edb.html#unexclude_processes/1"},{"type":"function","title":"edb.unsubscribe/1","doc":"Remove a previously added subscription. The caller process need not be the one holding the subscription. An unsubscribed event will be sent as final event to the subscription, which marks the end of the event stream.","ref":"edb.html#unsubscribe/1"},{"type":"function","title":"edb.wait/0","doc":"Waits until any process gets stopped.","ref":"edb.html#wait/0"},{"type":"type","title":"edb.add_breakpoint_error/0","doc":null,"ref":"edb.html#t:add_breakpoint_error/0"},{"type":"type","title":"edb.arg_parser/1","doc":null,"ref":"edb.html#t:arg_parser/1"},{"type":"type","title":"edb.breakpoint_info/0","doc":null,"ref":"edb.html#t:breakpoint_info/0"},{"type":"type","title":"edb.catch_handler/0","doc":null,"ref":"edb.html#t:catch_handler/0"},{"type":"type","title":"edb.event/0","doc":null,"ref":"edb.html#t:event/0"},{"type":"type","title":"edb.event_envelope/1","doc":null,"ref":"edb.html#t:event_envelope/1"},{"type":"type","title":"edb.event_subscription/0","doc":null,"ref":"edb.html#t:event_subscription/0"},{"type":"type","title":"edb.excluded_process_info/0","doc":null,"ref":"edb.html#t:excluded_process_info/0"},{"type":"type","title":"edb.exclusion_reason/0","doc":null,"ref":"edb.html#t:exclusion_reason/0"},{"type":"type","title":"edb.frame_id/0","doc":null,"ref":"edb.html#t:frame_id/0"},{"type":"type","title":"edb.fun_name/0","doc":null,"ref":"edb.html#t:fun_name/0"},{"type":"type","title":"edb.line/0","doc":null,"ref":"edb.html#t:line/0"},{"type":"type","title":"edb.process_info/0","doc":null,"ref":"edb.html#t:process_info/0"},{"type":"type","title":"edb.process_status/0","doc":null,"ref":"edb.html#t:process_status/0"},{"type":"type","title":"edb.procs_spec/0","doc":null,"ref":"edb.html#t:procs_spec/0"},{"type":"type","title":"edb.resumed_event/0","doc":null,"ref":"edb.html#t:resumed_event/0"},{"type":"type","title":"edb.stack_frame/0","doc":null,"ref":"edb.html#t:stack_frame/0"},{"type":"type","title":"edb.stack_frame_vars/0","doc":null,"ref":"edb.html#t:stack_frame_vars/0"},{"type":"type","title":"edb.start_error/0","doc":null,"ref":"edb.html#t:start_error/0"},{"type":"type","title":"edb.step_error/0","doc":null,"ref":"edb.html#t:step_error/0"},{"type":"type","title":"edb.step_out_error/0","doc":null,"ref":"edb.html#t:step_out_error/0"},{"type":"type","title":"edb.step_over_error/0","doc":null,"ref":"edb.html#t:step_over_error/0"},{"type":"type","title":"edb.stopped_event/0","doc":null,"ref":"edb.html#t:stopped_event/0"},{"type":"type","title":"edb.value/0","doc":null,"ref":"edb.html#t:value/0"},{"type":"module","title":"edb_app","doc":"edb public API","ref":"edb_app.html"},{"type":"function","title":"edb_app.start/2","doc":null,"ref":"edb_app.html#start/2"},{"type":"function","title":"edb_app.stop/1","doc":null,"ref":"edb_app.html#stop/1"},{"type":"module","title":"edb_dap","doc":"Support for the DAP Protocol The Debug Adapter Protocol (DAP) defines the abstract protocol used between a development tool (e.g. IDE or editor) and a debugger, using JSON-RPC as the underlying transport protocol. This module implements the types and functions required to encode and decode messages to and from the DAP protocol. For the full specification, please refer to: https://microsoft.github.io/debug-adapter-protocol/specification","ref":"edb_dap.html"},{"type":"function","title":"edb_dap.build_error_response/2","doc":null,"ref":"edb_dap.html#build_error_response/2"},{"type":"function","title":"edb_dap.decode_frames/1","doc":null,"ref":"edb_dap.html#decode_frames/1"},{"type":"function","title":"edb_dap.encode_frame/1","doc":null,"ref":"edb_dap.html#encode_frame/1"},{"type":"function","title":"edb_dap.frame/1","doc":null,"ref":"edb_dap.html#frame/1"},{"type":"function","title":"edb_dap.stack_frame/3","doc":null,"ref":"edb_dap.html#stack_frame/3"},{"type":"function","title":"edb_dap.thread_name/2","doc":null,"ref":"edb_dap.html#thread_name/2"},{"type":"function","title":"edb_dap.to_binary/1","doc":null,"ref":"edb_dap.html#to_binary/1"},{"type":"function","title":"edb_dap.unframe/1","doc":null,"ref":"edb_dap.html#unframe/1"},{"type":"type","title":"edb_dap.arguments/0","doc":null,"ref":"edb_dap.html#t:arguments/0"},{"type":"type","title":"edb_dap.body/0","doc":null,"ref":"edb_dap.html#t:body/0"},{"type":"type","title":"edb_dap.breakpoint/0","doc":null,"ref":"edb_dap.html#t:breakpoint/0"},{"type":"type","title":"edb_dap.breakpointMode/0","doc":null,"ref":"edb_dap.html#t:breakpointMode/0"},{"type":"type","title":"edb_dap.breakpointModeApplicability/0","doc":null,"ref":"edb_dap.html#t:breakpointModeApplicability/0"},{"type":"type","title":"edb_dap.breakpoints/0","doc":null,"ref":"edb_dap.html#t:breakpoints/0"},{"type":"type","title":"edb_dap.cancel_request_arguments/0","doc":null,"ref":"edb_dap.html#t:cancel_request_arguments/0"},{"type":"type","title":"edb_dap.cancel_response/0","doc":null,"ref":"edb_dap.html#t:cancel_response/0"},{"type":"type","title":"edb_dap.capabilities/0","doc":null,"ref":"edb_dap.html#t:capabilities/0"},{"type":"type","title":"edb_dap.checksum/0","doc":null,"ref":"edb_dap.html#t:checksum/0"},{"type":"type","title":"edb_dap.checksumAlgorithm/0","doc":"'MD5' | 'SHA1' | 'SHA256' | timestamp.","ref":"edb_dap.html#t:checksumAlgorithm/0"},{"type":"type","title":"edb_dap.columnDescriptor/0","doc":null,"ref":"edb_dap.html#t:columnDescriptor/0"},{"type":"type","title":"edb_dap.command/0","doc":null,"ref":"edb_dap.html#t:command/0"},{"type":"type","title":"edb_dap.continue_request_arguments/0","doc":null,"ref":"edb_dap.html#t:continue_request_arguments/0"},{"type":"type","title":"edb_dap.continue_response/0","doc":null,"ref":"edb_dap.html#t:continue_response/0"},{"type":"type","title":"edb_dap.disconnect_request_arguments/0","doc":null,"ref":"edb_dap.html#t:disconnect_request_arguments/0"},{"type":"type","title":"edb_dap.disconnect_response/0","doc":null,"ref":"edb_dap.html#t:disconnect_response/0"},{"type":"type","title":"edb_dap.error_response/0","doc":null,"ref":"edb_dap.html#t:error_response/0"},{"type":"type","title":"edb_dap.event/0","doc":null,"ref":"edb_dap.html#t:event/0"},{"type":"type","title":"edb_dap.event_type/0","doc":null,"ref":"edb_dap.html#t:event_type/0"},{"type":"type","title":"edb_dap.exceptionBreakpointsFilter/0","doc":null,"ref":"edb_dap.html#t:exceptionBreakpointsFilter/0"},{"type":"type","title":"edb_dap.exited_event_body/0","doc":null,"ref":"edb_dap.html#t:exited_event_body/0"},{"type":"opaque","title":"edb_dap.frame/0","doc":null,"ref":"edb_dap.html#t:frame/0"},{"type":"type","title":"edb_dap.initialize_request_arguments/0","doc":null,"ref":"edb_dap.html#t:initialize_request_arguments/0"},{"type":"type","title":"edb_dap.initialize_response/0","doc":null,"ref":"edb_dap.html#t:initialize_response/0"},{"type":"type","title":"edb_dap.initialized_event_body/0","doc":null,"ref":"edb_dap.html#t:initialized_event_body/0"},{"type":"type","title":"edb_dap.launch_request_arguments/0","doc":null,"ref":"edb_dap.html#t:launch_request_arguments/0"},{"type":"type","title":"edb_dap.launch_response/0","doc":null,"ref":"edb_dap.html#t:launch_response/0"},{"type":"type","title":"edb_dap.message/0","doc":null,"ref":"edb_dap.html#t:message/0"},{"type":"type","title":"edb_dap.next_request_arguments/0","doc":null,"ref":"edb_dap.html#t:next_request_arguments/0"},{"type":"type","title":"edb_dap.next_response/0","doc":null,"ref":"edb_dap.html#t:next_response/0"},{"type":"type","title":"edb_dap.protocol_message/0","doc":null,"ref":"edb_dap.html#t:protocol_message/0"},{"type":"type","title":"edb_dap.protocol_message_type/0","doc":null,"ref":"edb_dap.html#t:protocol_message_type/0"},{"type":"type","title":"edb_dap.request/0","doc":null,"ref":"edb_dap.html#t:request/0"},{"type":"type","title":"edb_dap.response/0","doc":null,"ref":"edb_dap.html#t:response/0"},{"type":"type","title":"edb_dap.run_in_terminal_request_arguments/0","doc":null,"ref":"edb_dap.html#t:run_in_terminal_request_arguments/0"},{"type":"type","title":"edb_dap.run_in_terminal_response/0","doc":null,"ref":"edb_dap.html#t:run_in_terminal_response/0"},{"type":"type","title":"edb_dap.scope/0","doc":null,"ref":"edb_dap.html#t:scope/0"},{"type":"type","title":"edb_dap.scopes_request_arguments/0","doc":null,"ref":"edb_dap.html#t:scopes_request_arguments/0"},{"type":"type","title":"edb_dap.scopes_response/0","doc":null,"ref":"edb_dap.html#t:scopes_response/0"},{"type":"type","title":"edb_dap.seq/0","doc":null,"ref":"edb_dap.html#t:seq/0"},{"type":"type","title":"edb_dap.set_breakpoints_request_arguments/0","doc":null,"ref":"edb_dap.html#t:set_breakpoints_request_arguments/0"},{"type":"type","title":"edb_dap.set_breakpoints_response/0","doc":null,"ref":"edb_dap.html#t:set_breakpoints_response/0"},{"type":"type","title":"edb_dap.source/0","doc":null,"ref":"edb_dap.html#t:source/0"},{"type":"type","title":"edb_dap.sourceBreakpoint/0","doc":"erlfmt:ignore","ref":"edb_dap.html#t:sourceBreakpoint/0"},{"type":"type","title":"edb_dap.stack_frame/0","doc":null,"ref":"edb_dap.html#t:stack_frame/0"},{"type":"type","title":"edb_dap.stack_frame_format/0","doc":null,"ref":"edb_dap.html#t:stack_frame_format/0"},{"type":"type","title":"edb_dap.stack_trace_request_arguments/0","doc":null,"ref":"edb_dap.html#t:stack_trace_request_arguments/0"},{"type":"type","title":"edb_dap.stack_trace_response/0","doc":null,"ref":"edb_dap.html#t:stack_trace_response/0"},{"type":"type","title":"edb_dap.step_out_request_arguments/0","doc":null,"ref":"edb_dap.html#t:step_out_request_arguments/0"},{"type":"type","title":"edb_dap.step_out_response/0","doc":null,"ref":"edb_dap.html#t:step_out_response/0"},{"type":"type","title":"edb_dap.stepping_granularity/0","doc":null,"ref":"edb_dap.html#t:stepping_granularity/0"},{"type":"type","title":"edb_dap.stopped_event_body/0","doc":null,"ref":"edb_dap.html#t:stopped_event_body/0"},{"type":"type","title":"edb_dap.target_node/0","doc":null,"ref":"edb_dap.html#t:target_node/0"},{"type":"type","title":"edb_dap.terminated_event_body/0","doc":null,"ref":"edb_dap.html#t:terminated_event_body/0"},{"type":"type","title":"edb_dap.thread/0","doc":null,"ref":"edb_dap.html#t:thread/0"},{"type":"type","title":"edb_dap.thread_id/0","doc":null,"ref":"edb_dap.html#t:thread_id/0"},{"type":"type","title":"edb_dap.threads/0","doc":null,"ref":"edb_dap.html#t:threads/0"},{"type":"type","title":"edb_dap.threads_request_arguments/0","doc":null,"ref":"edb_dap.html#t:threads_request_arguments/0"},{"type":"type","title":"edb_dap.threads_response/0","doc":null,"ref":"edb_dap.html#t:threads_response/0"},{"type":"type","title":"edb_dap.value_format/0","doc":null,"ref":"edb_dap.html#t:value_format/0"},{"type":"type","title":"edb_dap.variable/0","doc":null,"ref":"edb_dap.html#t:variable/0"},{"type":"type","title":"edb_dap.variable_presentation_hint/0","doc":null,"ref":"edb_dap.html#t:variable_presentation_hint/0"},{"type":"type","title":"edb_dap.variables_request_arguments/0","doc":null,"ref":"edb_dap.html#t:variables_request_arguments/0"},{"type":"type","title":"edb_dap.variables_response/0","doc":null,"ref":"edb_dap.html#t:variables_response/0"},{"type":"module","title":"edb_dap_events","doc":"DAP Events Handle events coming from the debugger. This function should be invoked by the DAP server.","ref":"edb_dap_events.html"},{"type":"function","title":"edb_dap_events.exited/3","doc":null,"ref":"edb_dap_events.html#exited/3"},{"type":"function","title":"edb_dap_events.stopped/2","doc":null,"ref":"edb_dap_events.html#stopped/2"},{"type":"type","title":"edb_dap_events.reaction/0","doc":null,"ref":"edb_dap_events.html#t:reaction/0"},{"type":"module","title":"edb_dap_id_mappings","doc":"An mapper of IDs for the debug adapter The DAP protocol expects numeric ids for threads, frames, scopes, etc. These ids are represented as number() in the JSON specification, and are expected to fit in a 64-bit float. Some ids like thread_ids are expected to be unique across the debugging session, while others (frame-ids, etc), need be unique only between pauses. The specification recommends adapters to reset them on continue requests. For more details see https://microsoft.github.io/debug-adapter-protocol/overview This module implements the mapping fo PIDs to thread-ids, etc, generically.","ref":"edb_dap_id_mappings.html"},{"type":"function","title":"edb_dap_id_mappings.frame_id_to_pid_frame/1","doc":null,"ref":"edb_dap_id_mappings.html#frame_id_to_pid_frame/1"},{"type":"function","title":"edb_dap_id_mappings.frame_scope_to_var_reference/1","doc":null,"ref":"edb_dap_id_mappings.html#frame_scope_to_var_reference/1"},{"type":"function","title":"edb_dap_id_mappings.handle_call/3","doc":null,"ref":"edb_dap_id_mappings.html#handle_call/3"},{"type":"function","title":"edb_dap_id_mappings.handle_cast/2","doc":null,"ref":"edb_dap_id_mappings.html#handle_cast/2"},{"type":"function","title":"edb_dap_id_mappings.handle_info/2","doc":null,"ref":"edb_dap_id_mappings.html#handle_info/2"},{"type":"function","title":"edb_dap_id_mappings.init/1","doc":null,"ref":"edb_dap_id_mappings.html#init/1"},{"type":"function","title":"edb_dap_id_mappings.pid_frame_to_frame_id/1","doc":null,"ref":"edb_dap_id_mappings.html#pid_frame_to_frame_id/1"},{"type":"function","title":"edb_dap_id_mappings.pid_to_thread_id/1","doc":null,"ref":"edb_dap_id_mappings.html#pid_to_thread_id/1"},{"type":"function","title":"edb_dap_id_mappings.reset/0","doc":null,"ref":"edb_dap_id_mappings.html#reset/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_frame_ids_server/0","doc":null,"ref":"edb_dap_id_mappings.html#start_link_frame_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_thread_ids_server/0","doc":"An integer that fits in a 64-bit float This is the requirement the DAP spec puts on ids.","ref":"edb_dap_id_mappings.html#start_link_thread_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.start_link_var_reference_ids_server/0","doc":null,"ref":"edb_dap_id_mappings.html#start_link_var_reference_ids_server/0"},{"type":"function","title":"edb_dap_id_mappings.thread_id_to_pid/1","doc":null,"ref":"edb_dap_id_mappings.html#thread_id_to_pid/1"},{"type":"function","title":"edb_dap_id_mappings.var_reference_to_frame_scope/1","doc":null,"ref":"edb_dap_id_mappings.html#var_reference_to_frame_scope/1"},{"type":"type","title":"edb_dap_id_mappings.frame_scope/0","doc":null,"ref":"edb_dap_id_mappings.html#t:frame_scope/0"},{"type":"type","title":"edb_dap_id_mappings.id/0","doc":null,"ref":"edb_dap_id_mappings.html#t:id/0"},{"type":"type","title":"edb_dap_id_mappings.id_mapping/1","doc":null,"ref":"edb_dap_id_mappings.html#t:id_mapping/1"},{"type":"type","title":"edb_dap_id_mappings.pid_frame/0","doc":null,"ref":"edb_dap_id_mappings.html#t:pid_frame/0"},{"type":"type","title":"edb_dap_id_mappings.scope/0","doc":null,"ref":"edb_dap_id_mappings.html#t:scope/0"},{"type":"type","title":"edb_dap_id_mappings.state/1","doc":null,"ref":"edb_dap_id_mappings.html#t:state/1"},{"type":"type","title":"edb_dap_id_mappings.validator/1","doc":null,"ref":"edb_dap_id_mappings.html#t:validator/1"},{"type":"module","title":"edb_dap_launch_config","doc":"DAP Launch Configuration Validation functions for the DAP launch configuration","ref":"edb_dap_launch_config.html"},{"type":"function","title":"edb_dap_launch_config.parse/1","doc":null,"ref":"edb_dap_launch_config.html#parse/1"},{"type":"type","title":"edb_dap_launch_config.field_validation/0","doc":null,"ref":"edb_dap_launch_config.html#t:field_validation/0"},{"type":"type","title":"edb_dap_launch_config.map_template/0","doc":null,"ref":"edb_dap_launch_config.html#t:map_template/0"},{"type":"type","title":"edb_dap_launch_config.predicate/0","doc":null,"ref":"edb_dap_launch_config.html#t:predicate/0"},{"type":"type","title":"edb_dap_launch_config.t/0","doc":null,"ref":"edb_dap_launch_config.html#t:t/0"},{"type":"type","title":"edb_dap_launch_config.value_validation/0","doc":null,"ref":"edb_dap_launch_config.html#t:value_validation/0"},{"type":"module","title":"edb_dap_requests","doc":"DAP Request Handlers The actual implementation for the DAP requests. This function should be invoked by the DAP server.","ref":"edb_dap_requests.html"},{"type":"function","title":"edb_dap_requests.continue/2","doc":null,"ref":"edb_dap_requests.html#continue/2"},{"type":"function","title":"edb_dap_requests.disconnect/2","doc":null,"ref":"edb_dap_requests.html#disconnect/2"},{"type":"function","title":"edb_dap_requests.initialize/2","doc":null,"ref":"edb_dap_requests.html#initialize/2"},{"type":"function","title":"edb_dap_requests.launch/2","doc":null,"ref":"edb_dap_requests.html#launch/2"},{"type":"function","title":"edb_dap_requests.next/2","doc":null,"ref":"edb_dap_requests.html#next/2"},{"type":"function","title":"edb_dap_requests.scopes/2","doc":null,"ref":"edb_dap_requests.html#scopes/2"},{"type":"function","title":"edb_dap_requests.set_breakpoints/2","doc":null,"ref":"edb_dap_requests.html#set_breakpoints/2"},{"type":"function","title":"edb_dap_requests.stack_trace/2","doc":null,"ref":"edb_dap_requests.html#stack_trace/2"},{"type":"function","title":"edb_dap_requests.step_out/2","doc":null,"ref":"edb_dap_requests.html#step_out/2"},{"type":"function","title":"edb_dap_requests.threads/2","doc":null,"ref":"edb_dap_requests.html#threads/2"},{"type":"function","title":"edb_dap_requests.variables/2","doc":null,"ref":"edb_dap_requests.html#variables/2"},{"type":"type","title":"edb_dap_requests.reaction/1","doc":null,"ref":"edb_dap_requests.html#t:reaction/1"},{"type":"type","title":"edb_dap_requests.stepper_response/0","doc":null,"ref":"edb_dap_requests.html#t:stepper_response/0"},{"type":"module","title":"edb_dap_responses","doc":"DAP Response Handlers The actual implementation for the DAP responses (reverse requests). This function should be invoked by the DAP server.","ref":"edb_dap_responses.html"},{"type":"function","title":"edb_dap_responses.run_in_terminal/2","doc":null,"ref":"edb_dap_responses.html#run_in_terminal/2"},{"type":"type","title":"edb_dap_responses.reaction/0","doc":null,"ref":"edb_dap_responses.html#t:reaction/0"},{"type":"module","title":"edb_dap_server","doc":"DAP server A simple debug adapter which can be used to interface with the edb Erlang debugger.","ref":"edb_dap_server.html"},{"type":"function","title":"edb_dap_server.handle_call/3","doc":null,"ref":"edb_dap_server.html#handle_call/3"},{"type":"function","title":"edb_dap_server.handle_cast/2","doc":null,"ref":"edb_dap_server.html#handle_cast/2"},{"type":"function","title":"edb_dap_server.handle_info/2","doc":null,"ref":"edb_dap_server.html#handle_info/2"},{"type":"function","title":"edb_dap_server.init/1","doc":null,"ref":"edb_dap_server.html#init/1"},{"type":"function","title":"edb_dap_server.start_link/0","doc":null,"ref":"edb_dap_server.html#start_link/0"},{"type":"function","title":"edb_dap_server.terminate/2","doc":null,"ref":"edb_dap_server.html#terminate/2"},{"type":"type","title":"edb_dap_server.action/0","doc":null,"ref":"edb_dap_server.html#t:action/0"},{"type":"type","title":"edb_dap_server.state/0","doc":null,"ref":"edb_dap_server.html#t:state/0"},{"type":"type","title":"edb_dap_server.transport_state/0","doc":null,"ref":"edb_dap_server.html#t:transport_state/0"},{"type":"module","title":"edb_dap_state","doc":"DAP state An interface around the state of the DAP server.","ref":"edb_dap_state.html"},{"type":"function","title":"edb_dap_state.get_context/1","doc":null,"ref":"edb_dap_state.html#get_context/1"},{"type":"function","title":"edb_dap_state.is_attached/1","doc":null,"ref":"edb_dap_state.html#is_attached/1"},{"type":"function","title":"edb_dap_state.is_initialized/1","doc":null,"ref":"edb_dap_state.html#is_initialized/1"},{"type":"function","title":"edb_dap_state.is_valid_subscription/2","doc":null,"ref":"edb_dap_state.html#is_valid_subscription/2"},{"type":"function","title":"edb_dap_state.make_target_node/1","doc":null,"ref":"edb_dap_state.html#make_target_node/1"},{"type":"function","title":"edb_dap_state.new/0","doc":null,"ref":"edb_dap_state.html#new/0"},{"type":"function","title":"edb_dap_state.set_context/2","doc":null,"ref":"edb_dap_state.html#set_context/2"},{"type":"function","title":"edb_dap_state.set_status/2","doc":null,"ref":"edb_dap_state.html#set_status/2"},{"type":"type","title":"edb_dap_state.context/0","doc":null,"ref":"edb_dap_state.html#t:context/0"},{"type":"type","title":"edb_dap_state.status/0","doc":null,"ref":"edb_dap_state.html#t:status/0"},{"type":"opaque","title":"edb_dap_state.t/0","doc":null,"ref":"edb_dap_state.html#t:t/0"},{"type":"type","title":"edb_dap_state.target_node/0","doc":null,"ref":"edb_dap_state.html#t:target_node/0"},{"type":"type","title":"edb_dap_state.target_node_type/0","doc":null,"ref":"edb_dap_state.html#t:target_node_type/0"},{"type":"module","title":"edb_dap_utils","doc":"DAP Request Handlers The actual implementation for the DAP requests. This function should be invoked by the DAP server.","ref":"edb_dap_utils.html"},{"type":"function","title":"edb_dap_utils.strip_suffix/2","doc":null,"ref":"edb_dap_utils.html#strip_suffix/2"},{"type":"module","title":"edb_main","doc":null,"ref":"edb_main.html"},{"type":"function","title":"edb_main.main/1","doc":null,"ref":"edb_main.html#main/1"},{"type":"module","title":"edb_node_monitor","doc":null,"ref":"edb_node_monitor.html"},{"type":"function","title":"edb_node_monitor.attach/2","doc":null,"ref":"edb_node_monitor.html#attach/2"},{"type":"function","title":"edb_node_monitor.attached_node/0","doc":null,"ref":"edb_node_monitor.html#attached_node/0"},{"type":"function","title":"edb_node_monitor.detach/0","doc":null,"ref":"edb_node_monitor.html#detach/0"},{"type":"function","title":"edb_node_monitor.handle_call/3","doc":null,"ref":"edb_node_monitor.html#handle_call/3"},{"type":"function","title":"edb_node_monitor.handle_cast/2","doc":null,"ref":"edb_node_monitor.html#handle_cast/2"},{"type":"function","title":"edb_node_monitor.handle_info/2","doc":null,"ref":"edb_node_monitor.html#handle_info/2"},{"type":"function","title":"edb_node_monitor.init/1","doc":null,"ref":"edb_node_monitor.html#init/1"},{"type":"function","title":"edb_node_monitor.start/0","doc":null,"ref":"edb_node_monitor.html#start/0"},{"type":"function","title":"edb_node_monitor.subscribe/0","doc":null,"ref":"edb_node_monitor.html#subscribe/0"},{"type":"function","title":"edb_node_monitor.terminate/2","doc":null,"ref":"edb_node_monitor.html#terminate/2"},{"type":"function","title":"edb_node_monitor.unsubscribe/1","doc":null,"ref":"edb_node_monitor.html#unsubscribe/1"},{"type":"type","title":"edb_node_monitor.call_request/0","doc":null,"ref":"edb_node_monitor.html#t:call_request/0"},{"type":"type","title":"edb_node_monitor.cast_request/0","doc":null,"ref":"edb_node_monitor.html#t:cast_request/0"},{"type":"type","title":"edb_node_monitor.start_opts/0","doc":null,"ref":"edb_node_monitor.html#t:start_opts/0"},{"type":"type","title":"edb_node_monitor.state/0","doc":null,"ref":"edb_node_monitor.html#t:state/0"},{"type":"module","title":"edb_server_break","doc":null,"ref":"edb_server_break.html"},{"type":"function","title":"edb_server_break.add_explicit/3","doc":null,"ref":"edb_server_break.html#add_explicit/3"},{"type":"function","title":"edb_server_break.add_steps_on_stack_frames/3","doc":null,"ref":"edb_server_break.html#add_steps_on_stack_frames/3"},{"type":"function","title":"edb_server_break.clear_explicit/3","doc":null,"ref":"edb_server_break.html#clear_explicit/3"},{"type":"function","title":"edb_server_break.create/0","doc":null,"ref":"edb_server_break.html#create/0"},{"type":"function","title":"edb_server_break.get_explicit_hit/2","doc":null,"ref":"edb_server_break.html#get_explicit_hit/2"},{"type":"function","title":"edb_server_break.get_explicits/1","doc":null,"ref":"edb_server_break.html#get_explicits/1"},{"type":"function","title":"edb_server_break.get_explicits/2","doc":null,"ref":"edb_server_break.html#get_explicits/2"},{"type":"function","title":"edb_server_break.get_explicits_hit/1","doc":null,"ref":"edb_server_break.html#get_explicits_hit/1"},{"type":"function","title":"edb_server_break.is_process_trapped/2","doc":"Returns true if the given process is either on an explicit breakpoint or a step breakpoint. Equivalently, returns true if the given process is on a VM breakpoint.","ref":"edb_server_break.html#is_process_trapped/2"},{"type":"function","title":"edb_server_break.register_breakpoint_event/5","doc":null,"ref":"edb_server_break.html#register_breakpoint_event/5"},{"type":"function","title":"edb_server_break.resume_processes/2","doc":null,"ref":"edb_server_break.html#resume_processes/2"},{"type":"opaque","title":"edb_server_break.breakpoints/0","doc":null,"ref":"edb_server_break.html#t:breakpoints/0"},{"type":"type","title":"edb_server_break.line/0","doc":null,"ref":"edb_server_break.html#t:line/0"},{"type":"type","title":"edb_server_break.vm_breakpoint_reason/0","doc":null,"ref":"edb_server_break.html#t:vm_breakpoint_reason/0"},{"type":"module","title":"edb_server_call_proc","doc":"Support for calling node processes that could be paused There are times were we want to call standard processed to query node state. Typically these processes will be excluded from debugging but if they are not, we want to make sure that the call fails, instead of the debugger getting blocked","ref":"edb_server_call_proc.html"},{"type":"function","title":"edb_server_call_proc.code_where_is_file/1","doc":null,"ref":"edb_server_call_proc.html#code_where_is_file/1"},{"type":"function","title":"edb_server_call_proc.safe_send_recv/4","doc":null,"ref":"edb_server_call_proc.html#safe_send_recv/4"},{"type":"type","title":"edb_server_call_proc.result/1","doc":null,"ref":"edb_server_call_proc.html#t:result/1"},{"type":"module","title":"edb_server_code","doc":null,"ref":"edb_server_code.html"},{"type":"function","title":"edb_server_code.fetch_fun_block_surrounding/2","doc":null,"ref":"edb_server_code.html#fetch_fun_block_surrounding/2"},{"type":"type","title":"edb_server_code.beam_lib_form/0","doc":null,"ref":"edb_server_code.html#t:beam_lib_form/0"},{"type":"type","title":"edb_server_code.beam_lib_forms/0","doc":null,"ref":"edb_server_code.html#t:beam_lib_forms/0"},{"type":"type","title":"edb_server_code.line/0","doc":null,"ref":"edb_server_code.html#t:line/0"},{"type":"module","title":"edb_server_maps","doc":null,"ref":"edb_server_maps.html"},{"type":"function","title":"edb_server_maps.add/3","doc":null,"ref":"edb_server_maps.html#add/3"},{"type":"function","title":"edb_server_maps.add/4","doc":null,"ref":"edb_server_maps.html#add/4"},{"type":"function","title":"edb_server_maps.add/5","doc":null,"ref":"edb_server_maps.html#add/5"},{"type":"module","title":"edb_server_sets","doc":null,"ref":"edb_server_sets.html"},{"type":"function","title":"edb_server_sets.fold/3","doc":null,"ref":"edb_server_sets.html#fold/3"},{"type":"function","title":"edb_server_sets.intersection/2","doc":null,"ref":"edb_server_sets.html#intersection/2"},{"type":"function","title":"edb_server_sets.is_element/2","doc":null,"ref":"edb_server_sets.html#is_element/2"},{"type":"function","title":"edb_server_sets.is_empty/1","doc":null,"ref":"edb_server_sets.html#is_empty/1"},{"type":"function","title":"edb_server_sets.map_subtract_keys/2","doc":null,"ref":"edb_server_sets.html#map_subtract_keys/2"},{"type":"function","title":"edb_server_sets.subtract/2","doc":null,"ref":"edb_server_sets.html#subtract/2"},{"type":"function","title":"edb_server_sets.take_element/2","doc":null,"ref":"edb_server_sets.html#take_element/2"},{"type":"function","title":"edb_server_sets.to_map/2","doc":null,"ref":"edb_server_sets.html#to_map/2"},{"type":"function","title":"edb_server_sets.union/1","doc":null,"ref":"edb_server_sets.html#union/1"},{"type":"function","title":"edb_server_sets.union/2","doc":null,"ref":"edb_server_sets.html#union/2"},{"type":"type","title":"edb_server_sets.set/1","doc":null,"ref":"edb_server_sets.html#t:set/1"},{"type":"module","title":"edb_sup","doc":"edb top level supervisor.","ref":"edb_sup.html"},{"type":"function","title":"edb_sup.init/1","doc":null,"ref":"edb_sup.html#init/1"},{"type":"function","title":"edb_sup.start_link/0","doc":null,"ref":"edb_sup.html#start_link/0"},{"type":"extras","title":"edb","doc":"edb\n=====\n\nThe next-generation debugger for Erlang.\n\nUsage\n-----\n\nPlease refer to the [user manual](https://whatsapp.github.io/edb/).\n\nLicense\n-------\n\nEDB is Apache 2.0 licensed, as found in the [LICENSE.md](./LICENSE.md) file.","ref":"readme.html"},{"type":"extras","title":"Apache License","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - Apache License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - Apache License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - Apache License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - Apache License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - Apache License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - Apache License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - Apache License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - Apache License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - Apache License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nAPPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}